/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.applications;

import java.awt.CardLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import org.visnow.vn.application.application.Application;
import org.visnow.vn.engine.Engine;
import org.visnow.vn.engine.core.CoreName;
import org.visnow.vn.engine.core.Link;
import org.visnow.vn.engine.core.ModuleCore;
import org.visnow.vn.engine.main.ModuleBox;
import org.visnow.vn.lib.basic.viewers.Viewer3D.Viewer3D;
import org.visnow.vn.system.main.VisNow;

/**
 *
 * @author know
 */


public class ApplicationFrame extends javax.swing.JFrame {

    protected Application application = new Application("viewer");
    protected Engine engine = application.getEngine();
    protected Map<String, String> mappers = new HashMap<>();
    protected List<JMenuItem> mappersMenuItems = new ArrayList<>();
    
    protected int counter = 0;
    protected Map<String, ModuleCore> modules = new HashMap<>(); 
    protected DefaultMutableTreeNode top =
                 new DefaultMutableTreeNode("start");
    protected DefaultTreeModel workTreeModel = new DefaultTreeModel(top);
    /**
     * Creates new form ApplicationFrame
     */
    public ApplicationFrame() {
        initComponents();
        mappers.put("slice", "org.visnow.vn.lib.basic.mappers.RegularFieldSlice.RegularFieldSlice");
        mappers.put("isosurface", "org.visnow.vn.lib.basic.mappers.Isosurface.Isosurface");
        mappers.put("isolines", "org.visnow.vn.lib.basic.mappers.Isolines.Isolines");
        mappers.put("glyphs", "org.visnow.vn.lib.basic.mappers.Glyphs.Glyphs");
        for (String s : mappers.keySet()) {
            JMenuItem mI = new JMenuItem(s);
            mI.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    String s = ((JMenuItem)e.getSource()).getText();
                    newModule(s, mappers.get(s));
                }
            });
            mappersMenu.add(mI);   
            workTree.setModel(workTreeModel);
        }
        moduleTree.addTreeSelectionListener(new TreeSelectionListener() {
            @Override
            public void valueChanged(TreeSelectionEvent e) {
                CardLayout cl = (CardLayout)moduleGUIPanel.getLayout();
                cl.show(moduleGUIPanel, (String)((DefaultMutableTreeNode)e.getPath().getLastPathComponent()).getUserObject());
            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        guiPanel = new javax.swing.JPanel();
        moduleGUIPanel = new javax.swing.JPanel();
        moduleTree = new org.visnow.vn.gui.widgets.DynamicTree();
        displayPanel = new javax.swing.JPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        readMenu = new javax.swing.JMenu();
        vnRegularFieldItem = new javax.swing.JMenuItem();
        vnIrregularFieldItem = new javax.swing.JMenuItem();
        ucdItem = new javax.swing.JMenuItem();
        filterMenu = new javax.swing.JMenu();
        mappersMenu = new javax.swing.JMenu();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        guiPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        guiPanel.setMinimumSize(new java.awt.Dimension(250, 100));
        guiPanel.setVerifyInputWhenFocusTarget(false);
        guiPanel.setLayout(new java.awt.BorderLayout());

        moduleGUIPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        moduleGUIPanel.setLayout(new java.awt.CardLayout());
        guiPanel.add(moduleGUIPanel, java.awt.BorderLayout.CENTER);

        moduleTree.setMinimumSize(new java.awt.Dimension(200, 200));
        moduleTree.setPreferredSize(new java.awt.Dimension(203, 203));
        guiPanel.add(moduleTree, java.awt.BorderLayout.NORTH);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel1.add(guiPanel, gridBagConstraints);

        displayPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        displayPanel.setMinimumSize(new java.awt.Dimension(500, 500));
        displayPanel.setName(""); // NOI18N
        displayPanel.setPreferredSize(new java.awt.Dimension(800, 800));
        displayPanel.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(displayPanel, gridBagConstraints);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        jMenu1.setText("File");
        jMenuBar1.add(jMenu1);

        readMenu.setText("Read data file");

        vnRegularFieldItem.setText("VisNow regular field");
        vnRegularFieldItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                vnRegularFieldItemActionPerformed(evt);
            }
        });
        readMenu.add(vnRegularFieldItem);

        vnIrregularFieldItem.setText("VisNow irregular field");
        vnIrregularFieldItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                vnIrregularFieldItemActionPerformed(evt);
            }
        });
        readMenu.add(vnIrregularFieldItem);

        ucdItem.setText("UCD text file");
        ucdItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ucdItemActionPerformed(evt);
            }
        });
        readMenu.add(ucdItem);

        jMenuBar1.add(readMenu);

        filterMenu.setText("Modify data");
        jMenuBar1.add(filterMenu);

        mappersMenu.setText("Visualize");
        jMenuBar1.add(mappersMenu);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void vnRegularFieldItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_vnRegularFieldItemActionPerformed
        newModule("VN regular field reader", "org.visnow.vn.lib.basic.readers.ReadVisNowField.ReadVisNowField");
        addLink("VN regular field reader", "outObj", "viewer 3D", "inObject");
        moduleTree.addObject(moduleTree.setRootSelected(), "VN irregular field reader", true);
    }//GEN-LAST:event_vnRegularFieldItemActionPerformed
        
    private void ucdItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ucdItemActionPerformed
        newModule("UCD reader", "org.visnow.vn.lib.basic.readers.ReadUCD.ReadUCD");
        addLink("UCD reader", "outObj", "viewer 3D", "inObject");
        moduleTree.addObject(moduleTree.setRootSelected(), "UCD reader", true);
    }//GEN-LAST:event_ucdItemActionPerformed

    private void vnIrregularFieldItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_vnIrregularFieldItemActionPerformed
        newModule("VN irregular field reader", "org.visnow.vn.lib.basic.readers.ReadVisNowField.ReadVisNowField");
        addLink("VN irregular field reader", "outObj", "viewer 3D", "inObject");
        moduleTree.addObject(moduleTree.setRootSelected(), "VN irregular field reader", true);// TODO add your handling code here:
    }//GEN-LAST:event_vnIrregularFieldItemActionPerformed

    public JPanel getDisplayPanel() {
        return displayPanel;
    }

    public JPanel getGuiPanel() {
        return guiPanel;
    }
 
    protected final ModuleCore addModule(String name, String classDesc)
    {
        try {
            ModuleCore core = application.getLibraries().generateCore(new CoreName("internal", classDesc));
            core.setHideGUIwhenNoData(false);
            core.setApplication(application);
            ModuleBox mb = new ModuleBox(engine, name, core);
            engine.getModules().put(name, mb);
            mb.run();
            core.onInitFinished();
            return core;
        } catch (Exception e) {
            return null;
        }
    }

    protected final void newModule(String name, String classDesc)
    {
        ModuleCore modCore = addModule(name, classDesc);
        moduleGUIPanel.add(modCore.getPanel(), name);
        modules.put(name, modCore);
        moduleTree.addObject(moduleTree.getSelected(), name, true);
        top.add(new DefaultMutableTreeNode(name, true));
    }

    protected final Link addLink(String source, String sourcePort, String target, String targetPort)
    {
        try {
            return new Link(engine.getModule(source).getOutput(sourcePort),
                            engine.getModule(target).getInput(targetPort));
        } catch (Exception e) {
            return null;
        }
    }

   /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Create and display the form */
        VisNow.mainBlocking(args, false);
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                ApplicationFrame frame = new ApplicationFrame();
                Viewer3D viewer = ((Viewer3D) frame.addModule("viewer 3D", 
                            "org.visnow.vn.lib.basic.viewers.Viewer3D.Viewer3D"));
                viewer.setShowFrameOnActive(false);
                viewer.getWindow().setVisible(false);
                viewer.setShowFrameOnActive(false);
                frame.getDisplayPanel().add(viewer.getDisplayPanel());
                frame.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel displayPanel;
    private javax.swing.JMenu filterMenu;
    private javax.swing.JPanel guiPanel;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JMenu mappersMenu;
    private javax.swing.JPanel moduleGUIPanel;
    private org.visnow.vn.gui.widgets.DynamicTree moduleTree;
    private javax.swing.JMenu readMenu;
    private javax.swing.JMenuItem ucdItem;
    private javax.swing.JMenuItem vnIrregularFieldItem;
    private javax.swing.JMenuItem vnRegularFieldItem;
    private javax.swing.JTree workTree;
    // End of variables declaration//GEN-END:variables
}
